#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire200four4xi.py">
#<abstract4xi abstract = "fires to direction four and to distance 200"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire200four4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

       
# -------------------------------------------------------------------------------------------------
# SHOT2FOUR - COORDINATE SIGNS OF SHOOT2FOUR4XI: (X + ,Y - ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2four2004xi    


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

shot2four2004xi = {
                1:'103x-122y118z',
                2:'103x-43y165z',
                3:'103x-89y145z',
                4:'107x-166y27z',
                5:'107x-38y164z',
                6:'109x-84y144z',
                7:'10x-194y46z',
                8:'110x-33y163z',
                9:'111x-118y117z',
                10:'113x-27y162z',
                11:'115x-79y142z',
                12:'116x-160y25z',
                13:'116x-21y161z',
                14:'117x-112y115z',
                15:'119x-15y159z',
                16:'11x-9y199z',
                17:'120x-74y141z',
                18:'121x-9y158z',
                19:'123x-3y157z',
                20:'124x-107y113z',
                21:'125x-154y23z',
                22:'125x-68y140z',
                23:'129x-62y138z',
                24:'130x-101y112z',
                25:'133x-147y21z',
                26:'134x-56y137z',
                27:'136x-94y110z',
                28:'138x-49y135z',
                29:'13x-38y195z',
                30:'13x-9y199z',
                31:'140x-140y19z',
                32:'141x-42y134z',
                33:'142x-88y108z',
                34:'145x-35y132z',
                35:'148x-133y17z',
                36:'148x-28y131z',
                37:'148x-81y107z',
                38:'150x-20y129z',
                39:'152x-12y128z',
                40:'153x-73y105z',
                41:'154x-125y15z',
                42:'154x-4y126z',
                43:'157x-66y103z',
                44:'161x-117y13z',
                45:'167x-108y11z',
                46:'16x-39y195z',
                47:'16x-9y199z',
                48:'173x-99y9z',
                49:'178x-90y7z',
                50:'182x-81y5z',
                51:'186x-71y3z',
                52:'18x-9y198z',
                53:'190x-61y1z',
                54:'193x-51y0z',
                55:'19x-40y194z',
                56:'20x-193y45z',
                57:'20x-9y198z',
                58:'22x-40y194z',
                59:'23x-9y198z',
                60:'242x-87y153z',
                61:'25x-41y194z',
                62:'25x-8y198z',
                63:'27x-8y197z',
                64:'28x-41y193z',
                65:'30x-192y43z',
                66:'30x-7y197z',
                67:'31x-41y193z',
                68:'32x-5y197z',
                69:'32x-79y180z',
                70:'34x-4y196z',
                71:'35x-41y192z',
                72:'36x-2y196z',
                73:'37x-79y179z',
                74:'38x-40y191z',
                75:'38x0y196z',
                76:'40x-191y41z',
                77:'42x-40y191z',
                78:'42x-78y178z',
                79:'45x-39y190z',
                80:'47x-78y177z',
                81:'49x-37y190z',
                82:'50x-189y39z',
                83:'52x-36y189z',
                84:'52x-76y176z',
                85:'53x-112y156z',
                86:'56x-34y188z',
                87:'57x-75y176z',
                88:'59x-111y154z',
                89:'59x-32y188z',
                90:'60x-186y37z',
                91:'62x-29y187z',
                92:'62x-73y175z',
                93:'65x-27y186z',
                94:'66x-109y153z',
                95:'67x-71y174z',
                96:'69x-24y186z',
                97:'70x-183y35z',
                98:'71x-21y185z',
                99:'72x-69y173z',
                100:'73x-107y152z',
                101:'73x-137y125z',
                102:'74x-17y184z',
                103:'77x-14y183z',
                104:'77x-66y172z',
                105:'79x-104y151z',
                106:'79x-10y183z',
                107:'80x-180y33z',
                108:'81x-134y123z',
                109:'82x-63y171z',
                110:'82x-6y182z',
                111:'84x-2y181z',
                112:'85x-101y149z',
                113:'86x-59y169z',
                114:'89x-131y121z',
                115:'89x-176y31z',
                116:'91x-56y168z',
                117:'91x-97y148z',
                118:'95x-52y167z',
                119:'96x-127y120z',
                120:'98x-171y29z',
                121:'98x-93y147z',
                122:'99x-47y166z'}

#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire200four4xi" usage = "target function for charge2004xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire200four4xi(queue2four, consumer_channel2four, publisher_channel2four):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE200FOUR4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE200FOUR4XI -  QUEUE2FOUR: ", queue2four)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE200FOUR4XI -  CONSUMER_CHANNEL2FOUR: ", consumer_channel2four)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE200FOUR4XI -  PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE200FOUR4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2four.put(shot2four2004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE200FOUR4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE200FOUR4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE200FOUR4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2four8shot2four2004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2four8shot2four2004xi</nack2put4xi>" 
            
        publisher_channel2four.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE200FOUR4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE200FOUR4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE200FOUR4XI - RETURNING QUEUE OBJECT QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi())  
        # 
            
    return queue2four    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire200four4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                    